<template>
  <div class="container py-10 h-auto px-6 mx-auto">
    <div class="mt-6 max-w-2xl mx-auto sm:px-6 lg:max-w-7xl lg:px-8">
      <h1
        class="text-center text-4xl tracking-tight font-extrabold text-gray-900 sm:text-5xl md:text-6xl"
      >
        Ma WishList
      </h1>
    </div>

    <div class="mt-6 max-w-2xl mx-auto sm:px-6 lg:max-w-7xl lg:px-8 grid gap-8">
      <div v-for="(wish, key) in wishs" :key="`${key}`">
        <WishCard
          :name="wish.name"
          :studio="wish.studio.name"
          :image="wish.image"
          :id="wish.wishId"
          :idjeu="wish.id"
          @delete="() => deleteWish(key)"
        />
      </div>
    </div>
  </div>
</template>

<script>
import WishCard from "./WishCard"

export default {
  name: "Profil",
  components: {
    WishCard
  },
  data() {
    return {
      wishs: [],
      urlGetWish: `https://${window.location.hostname}:8443/wish/user/`,
      urlGetGame: `https://${window.location.hostname}:8443/games/`
    }
  },
  inject: ["user", "createAlert"],
  beforeMount() {
    const headers = {
      Accept: "application/json",
      "Content-Type": "application/json",
      Authorization: "Bearer " + this.user.token
    }

    fetch(this.urlGetWish + this.user.id, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        data.forEach((elt) => {

          fetch(this.urlGetGame + elt.game_id, {
            headers,
            method: "GET"
          })
            .then((res) => {
              if (res.ok) {
                return res.json()
              } else {
                throw new Error("Something went wrong")
              }
            })
            .then((data) => {
              data = {
                ...data,
                wishId: elt._id
              }
              this.wishs.push(data)
            })
            .catch(() => {
              this.createAlert({
                color: "red",
                text: "Ce jeu n'existe pas",
                icon: "times"
              })
            })
        })
      })
      .catch(() => {
        this.createAlert({
          color: "red",
          text: "Ce jeu n'existe pas",
          icon: "times"
        })
      })
  },
  methods: {
    deleteWish: function(key) {
      this.wishs.splice(key, 1)
      this.$router.go()
    }
  }
}
</script>

<style scoped></style>
